<template>
  <div class="navbar">
    <hamburger :is-active="sidebar.opened" class="hamburger-container" @toggleClick="toggleSideBar"/>

    <breadcrumb class="breadcrumb-container"/>

    <div class="right-menu">
      <el-dropdown class="avatar-container" trigger="click">
        <div class="avatar-wrapper">
          <p>当前所属门店：{{ barName }}</p>
          <i class="el-icon-caret-bottom"/>
        </div>
        <el-dropdown-menu slot="dropdown">
          <el-dropdown-item
            v-for="item in outletList"
            :key="item.id"
            @click.native="handleSelectOutlet(item)">
            <span style="display:block;">{{ item.bar_name }}</span>
          </el-dropdown-item>
        </el-dropdown-menu>
      </el-dropdown>
      <i style="margin-right: 30px;"></i>
      <el-dropdown class="avatar-container" trigger="click">
        <div class="avatar-wrapper">
          <p>{{ name }}</p>
          <i class="el-icon-caret-bottom"/>
        </div>
        <el-dropdown-menu slot="dropdown">
          <router-link to="/">
            <el-dropdown-item>
              主页
            </el-dropdown-item>
          </router-link>
          <el-dropdown-item @click.native="modPassword">
            <span style="display:block;">修改密码</span>
          </el-dropdown-item>
          <el-dropdown-item divided @click.native="logout">
            <span style="display:block;">退出登录</span>
          </el-dropdown-item>
        </el-dropdown-menu>
      </el-dropdown>
    </div>
    <modPassword v-if="modPasswordDialog.show" v-model="modPasswordDialog.show"></modPassword>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
import Breadcrumb from '@/components/Breadcrumb'
import Hamburger from '@/components/Hamburger'
import modPassword from '@/components/_dialog/modPassword'
import { getBarId, getBarName, setBarId, setBarName } from '@/utils/auth'

export default {
  components: {
    Breadcrumb,
    Hamburger,
    modPassword
  },
  computed: {
    ...mapGetters([
      'sidebar',
      'avatar',
      'name',
      'outletList'
    ]),
    barName () {
      return getBarName()
    },
    barId () {
      return getBarId()
    }
  },
  data () {
    return {
      modPasswordDialog: {
        show: false,
      }
    }
  },
  created () {
    this.$store.dispatch('common/fetchOutletList')
    this.$store.dispatch('common/fetchCategory')
    this.$store.dispatch('common/fetchGoodsAttr')
    this.$store.dispatch('common/fetchGoodsArr')
  },
  methods: {
    modPassword () {
      this.modPasswordDialog.show = true
    },
    toggleSideBar () {
      this.$store.dispatch('app/toggleSideBar')
    },
    async logout () {
      await this.$store.dispatch('user/logout')
      this.$router.push(`/login`)
    },
    handleSelectOutlet (item) {
      if (item.id.toString() === this.barId) {
        return
      }
      this.$confirm('确定要切换门店吗', '确认', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(async () => {
        const data = await this.$fetch('/v1/user/member/changeBar', { id: item.id })
        if (data.code === 200) {
          this.$message.success('门店切换成功')
          setBarId(item.id)
          setBarName(item.bar_name)
          setTimeout(() => {
            location.reload()
          }, 2000)
        }
      }).catch(() => {})
    }
  }
}
</script>

<style lang="scss" scoped>
.navbar {
  height: 50px;
  overflow: hidden;
  position: relative;
  background: #fff;
  box-shadow: 0 1px 4px rgba(0, 21, 41, .08);

  .hamburger-container {
    line-height: 46px;
    height: 100%;
    float: left;
    cursor: pointer;
    transition: background .3s;
    -webkit-tap-highlight-color: transparent;

    &:hover {
      background: rgba(0, 0, 0, .025)
    }
  }

  .breadcrumb-container {
    float: left;
  }

  .right-menu {
    float: right;
    height: 100%;
    line-height: 50px;

    &:focus {
      outline: none;
    }

    .right-menu-item {
      display: inline-block;
      padding: 0 8px;
      height: 100%;
      font-size: 18px;
      color: #5a5e66;
      vertical-align: text-bottom;

      &.hover-effect {
        cursor: pointer;
        transition: background .3s;

        &:hover {
          background: rgba(0, 0, 0, .025)
        }
      }
    }

    .avatar-container {
      margin-right: 30px;

      .avatar-wrapper {
        margin-top: 5px;
        position: relative;

        .el-icon-caret-bottom {
          cursor: pointer;
          position: absolute;
          right: -20px;
          top: 20px;
          font-size: 12px;
        }
      }
    }
  }
}
</style>
